package com.swair.reservation;

/*
* Cette exception est lance en cas de problme de rservation.
*
* @version  1.0
*/
public class ReservationException extends Exception {

	/*
	* L'exception systme  l'origine de cette exception de
	* rservation.
	*
	* @serial
	*/
	private Throwable rootCause;

	/*
	* Ce constructeur permet de crer une exception de rservation
	* sans message d'anomalie associ.
	*/
	public ReservationException() {
		super();
	}

	/*
	* Ce constructeur permet de crer une exception de rservation
	* avec un message d'anomalie associ.
	*
	* @param		message le message d'anomalie associ
	*/
	public ReservationException(String message) {
		super(message);
	}

	/*
	* Ce constructeur permet de crer une exception de rservation
	* avec un message d'anomalie associ et d'y ajouter l'exception
	* systme  l'origine de cette exception de rservation.
	*
	* @param		message le message d'anomalie associ
	* @param		rootCause l'exception systme  l'origine de 
	*				cette exception de rservation
	*/
	public ReservationException(String message, Throwable rootCause) {
		super(message);
		this.rootCause=rootCause;
	}

	/*
	* Ce constructeur permet de crer une exception de rservation
	* et d'y ajouter un message d'anomalie relatif  l'exception
	* systme  l'origine de cette exception de rservation.
	*
	* @param		rootCause l'exception systme  l'origine de 
	*				cette exception de rservation
	*/
	public ReservationException(Throwable rootCause) {
		super(rootCause.getLocalizedMessage());
		this.rootCause=rootCause;
	}
	/*
	* Renvoie l'exception systme <code>Throwable</code>  l'origine 
	* de cette exception de rservation. 
	*
	* @return		Throwable l'exception systme <code>Throwable</code>
	* 				 l'origine de cette exception de rservation
	*/
	public Throwable getRootCause() {
		return rootCause;
	}
}